 /**
 * Sample React Native App
 * https://github.com/facebook/react-native
 *
 * @format
 * @flow
 */

import React, {Component} from 'react';
import { BackHandler } from 'react-native';
import {AppRegistry,Platform,AppState, StyleSheet, View, Text, Modal, Button, TouchableOpacity, Alert, NativeModules, NativeEventEmitter, Image} from 'react-native';
const MrzScanner = NativeModules.RNMrzscannerlib;
const EventEmitter = new NativeEventEmitter(MrzScanner);
var subscription;



export default class App extends Component<Props> {
  constructor() {
    super()
    this.state = {
      value : '',
    }
  }


componentDidMount(){   
      subscription=EventEmitter.addListener
      ('successfulScanEmittedEvent',
        (body) => 
         console.log("Results" + body.surname,
                                 body.document_type_readable,
                                 body.issuing_country,
                                 body.surname,
                                 body.document_number,
                                 body.nationality,
                                 body.dob_raw,
                                 body.dob_readable,
                                 body.sex )
    );
       subscription=EventEmitter.addListener
       ('successfulDocumentScanEmittedEvent', (body) => { 
        this.setState({value : body});
       }
    );
  
       subscription=EventEmitter.addListener
       ('scannerWasDismissedEmittedEvent', (body) => { 
        console.log("onBackPressed" + body + "back pressed")
       }
    );
    }

     componentWillDismount(){
    subscription.remove();
  }

  render(){   

    return(
      <View style={styles.container}>
      
        <Button
          title="scan 1"
          onPress={() => {
          MrzScanner.setMaxThreads(2)
          MrzScanner.setScannerType(0)
          MrzScanner.toggleFlash(true)
          MrzScanner.startScanner()
        }}/>


        <Button
          title="scan 2"
          onPress={() => {
         MrzScanner.setMaxThreads(2)
         MrzScanner.setScannerType(1)
         MrzScanner.startScanner()
            Alert.alert(
                "Alert Title",
                "Alert Msg",
                [ { text: "CancelScanner", onPress: () => MrzScanner.closeScanner()
                },
                  { text: "Resume Scanner", onPress: () =>  MrzScanner.resumeScanner() }
                ],
                { cancelable: true }
              );
                    

        }}/>
        <Button
          title="scan 3"
          onPress={() => {
          MrzScanner.setMaxThreads(2)
          MrzScanner.setScannerType(2)
          MrzScanner.startScanner()
      

        }}/>
       
          <Button
          title="scan from gallery"
          onPress={() => {
         MrzScanner.scanFromGallery()

        }}/>
        <Image style={{width: '100%',height: 350}} resizeMode= 'contain' source={{uri: `data:image/png;base64,${this.state.value}`}} />

      </View>

         );
   }
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    justifyContent: 'center',
    alignItems: 'center',
    backgroundColor: '#F5FCFF',
  },
  welcome: {
    fontSize: 20,
    textAlign: 'center',
    margin: 10,
  },
  instructions: {
    textAlign: 'center',
    color: '#333333',
    marginBottom: 5,
  },
});
